unit Main;

interface

uses
  Windows, DBXpress, FMTBcd, DBClient, Provider, DB, SqlExpr, DBCtrls,
  ComCtrls, StdCtrls, ExtCtrls, Classes, Controls, Grids, DBGrids, Forms,
  SysUtils, DBLocal, SimpleDS;

type
  TfmMain = class(TForm)
    DBGrid: TDBGrid;
    DataSource: TDataSource;
    ToolBar: TPanel;
    btOpen: TButton;
    btClose: TButton;
    btExecute: TButton;
    meSQL: TMemo;
    StatusBar: TStatusBar;
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    btApplyUpdates: TButton;
    btCancelUpdates: TButton;
    SimpleDataSet: TSimpleDataSet;
    Label1: TLabel;
    edServerName: TEdit;
    edDatabase: TEdit;
    SQLConnection: TSQLConnection;
    procedure btOpenClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure btExecuteClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure meSQLExit(Sender: TObject);
    procedure btApplyUpdatesClick(Sender: TObject);
    procedure btCancelUpdatesClick(Sender: TObject);
    procedure SimpleDataSetAfterExecute(Sender: TObject;
      var OwnerData: OleVariant);
    procedure edServerNameExit(Sender: TObject);
    procedure edDatabaseExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure ShowState;
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;

implementation

{$R *.dfm}

procedure TfmMain.ShowState;
var
  St:string;

  procedure AddSt(S:string);
  begin
    if St <> '' then
      St := St + ', ';
    St := St + S;
  end;

begin
  St := '';

  if SimpleDataSet.Active then
    AddSt('Active')
  else
    AddSt('Inactive');

  StatusBar.Panels[0].Text := St;
end;

procedure TfmMain.meSQLExit(Sender: TObject);
begin
  if Trim(SimpleDataSet.DataSet.CommandText) <> Trim(meSQL.Lines.Text) then
    SimpleDataSet.DataSet.CommandText := meSQL.Lines.Text;
  ShowState;
end;

procedure TfmMain.btOpenClick(Sender: TObject);
begin
  try
    meSQLExit(nil);
    SimpleDataSet.Open;
  finally
    ShowState;
  end;
end;

procedure TfmMain.btCloseClick(Sender: TObject);
begin
  SimpleDataSet.Close;
  ShowState;
end;

procedure TfmMain.btExecuteClick(Sender: TObject);
begin
  try
    SimpleDataSet.Execute;
  finally
    ShowState;
  end;
end;

procedure TfmMain.FormShow(Sender: TObject);
begin
  edServerName.Text := SQLConnection.Params.Values['HostName'];
  edDatabase.Text := SQLConnection.Params.Values['Database'];
  SimpleDataSet.DataSet.CommandText := meSQL.Lines.Text;
  ShowState;
end;

procedure TfmMain.btApplyUpdatesClick(Sender: TObject);
var
  i: integer;
begin
  i := SimpleDataSet.ApplyUpdates(0);
  if i <> 0 then
    raise Exception.Create('Error on ApplyUpdates occured');
end;

procedure TfmMain.btCancelUpdatesClick(Sender: TObject);
begin
  SimpleDataSet.CancelUpdates;
end;

procedure TfmMain.SimpleDataSetAfterExecute(Sender: TObject;
  var OwnerData: OleVariant);
begin
  ShowState;

  MessageBeep(1);
end;

procedure TfmMain.edServerNameExit(Sender: TObject);
begin
  SQLConnection.Params.Values['HostName'] := edServerName.Text;
end;

procedure TfmMain.edDatabaseExit(Sender: TObject);
begin
  SQLConnection.Params.Values['Database'] := edDatabase.Text;
end;

procedure TfmMain.FormCreate(Sender: TObject);
begin
{$IFDEF LINUX}
  SQLConnection.LibraryName := {$I ../LibName.inc};
{$ENDIF}
end;

end.

